/*
 * +=============================================================================================+
 * | Program : scani2c.ino                                                                       |
 * | Author  : Mike G7GTN                                                                        |
 * | Date    : July 2017                                                                         | 
 * +=============================================================================================+ 
 * 
 *  Scan I2C Bus for any connected devices
 */

#include <Wire.h>

//--------------------------------------------------------------------------
// Main set-up
void setup() 
{ 
   Wire.begin( );
  
   Serial.begin(115200);
   Serial.flush();
   scanbus();                        
}

//--------------------------------------------------------------------------
// Look for I2C Addresses
void scanbus()
{
  Serial.println ("[I2C Scanning]");
  byte count = 0;
  Wire.begin();
  for (byte i = 1; i < 127; i++)                  // I2C address range
  {
    Wire.beginTransmission (i);
    if (Wire.endTransmission () == 0)
      {
      Serial.print ("Found device at address: ");
      Serial.print ("Decimal ");
      Serial.print (i, DEC);
      Serial.print (" Hexadecimal(0x");
      Serial.print (i, HEX);
      Serial.println (")");
      count++;
      delay (1);  
      } 
  } 
  Serial.print ("Found ");
  Serial.print (count, DEC);
  Serial.println (" I2C device(s).");
  Serial.println ("[Finished Scan]");     
}  

//--------------------------------------------------------------------------
// 
void loop() 
{
    
}
