/*
 * +=============================================================================================+
 * | Program : serialctrl.ino                                                                    |
 * | Author  : Mike G7GTN                                                                        |
 * | Date    : August 2017                                                                       | 
 * +=============================================================================================+ 
 * 
 *  Send I2C commands from a serial menu @ 115200 baudrate
 *  
 *   If you changed the I2C bus address in the GCB code then you also need to change 
 *   it here to both match.
 *   
 *
 *  PIC 
 *
 *   A 18F2520 was to hand and hence used for these tests.
*/

#include <Wire.h>

//--------------------------------------------------------------------------
// Main set-up
void setup() 
{ 
    Wire.begin(0x99);			      // Address must match GCB slave code   
    Serial.begin(115200);
    Serial.flush(); 
    menu();  				      // Show user menu                    
}

//--------------------------------------------------------------------------
// Show user serial menu
void menu(void)
{
   Serial.println("------------------------------");
   Serial.println("  I2C Video Switch Control    ");
   Serial.println("------------------------------");
   Serial.println(" ");
   Serial.println("[1] - Channel 1");
   Serial.println("[2] - Channel 2");
   Serial.println("[3] - Channel 3");
   Serial.println("[4] - Channel 4");
   Serial.println(" ");
   Serial.println("Please Select Number then Enter");          
}

//--------------------------------------------------------------------------
// Select channel from user
void loop() 
{
    byte b;
    if(Serial.available())
    {
      b = Serial.read();

      switch(b)
      {
        case '1':  Wire.write(0x01);  Wire.endTransmission(); break;
        case '2':  Wire.write(0x02);  Wire.endTransmission(); break;
        case '3':  Wire.write(0x03);  Wire.endTransmission(); break;
        case '4':  Wire.write(0x04);  Wire.endTransmission(); break;
      }              
    }          
}
