;Program compiled by Great Cow BASIC (0.97.01 2017-02-20)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=18F2520, r=DEC
#include <P18F2520.inc>
 CONFIG LVP = OFF, MCLRE = ON, WDT = OFF, OSC = INTIO67

;********************************************************************************

;Set aside memory locations for variables
DELAYTEMP	EQU	0
HI2CBUFFER	EQU	1517
HI2CCURRENTMODE	EQU	13
HI2CDATAPRESENT	EQU	16
HI2CDATAREQUESTED	EQU	17
HI2CERRORCODE	EQU	18
HI2CFORLOOP	EQU	19
HI2CINDEX	EQU	20
HI2CMESSAGESIZE	EQU	21
HI2CSLAVETMPSTAT	EQU	22
I2CADDRESS	EQU	23
I2CBYTE	EQU	24
I2CTEMP	EQU	25
SAVEFSR0H	EQU	26
SAVEFSR0L	EQU	27
SAVESYSBYTETEMPA	EQU	28
SAVESYSBYTETEMPB	EQU	29
SAVESYSBYTETEMPX	EQU	30
SAVESYSDIVLOOP	EQU	31
SAVESYSDIVMULTA	EQU	32
SAVESYSDIVMULTA_H	EQU	33
SAVESYSDIVMULTB	EQU	34
SAVESYSDIVMULTB_H	EQU	35
SAVESYSDIVMULTX	EQU	36
SAVESYSDIVMULTX_H	EQU	37
SAVESYSTEMP1	EQU	38
SAVESYSWORDTEMPA_H	EQU	39
SAVESYSWORDTEMPB_H	EQU	40
SAVESYSWORDTEMPX_H	EQU	41
SYSBSR	EQU	42
SYSBYTETEMPA	EQU	5
SYSBYTETEMPB	EQU	9
SYSBYTETEMPX	EQU	0
SYSDIVLOOP	EQU	4
SYSDIVMULTA	EQU	7
SYSDIVMULTA_H	EQU	8
SYSDIVMULTB	EQU	11
SYSDIVMULTB_H	EQU	12
SYSDIVMULTX	EQU	2
SYSDIVMULTX_H	EQU	3
SYSSTATUS	EQU	15
SYSTEMP1	EQU	43
SYSTEMP1_H	EQU	44
SYSTEMP2	EQU	45
SYSW	EQU	14
SYSWAITTEMP10US	EQU	5
SYSWORDTEMPA	EQU	5
SYSWORDTEMPA_H	EQU	6
SYSWORDTEMPB	EQU	9
SYSWORDTEMPB_H	EQU	10
SYSWORDTEMPX	EQU	0
SYSWORDTEMPX_H	EQU	1
TONEDURATION	EQU	46
TONEDURATION_H	EQU	47
TONEFREQUENCY	EQU	48
TONEFREQUENCY_H	EQU	49
TONELOOP	EQU	50
TONELOOP2	EQU	52
TONELOOP2_H	EQU	53
TONELOOP_H	EQU	51
TONEPERIOD	EQU	54

;********************************************************************************

;Alias variables
AFSR0	EQU	4073
AFSR0_H	EQU	4074
SYSHI2CBUFFER_0	EQU	1517

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	8
	bra	INTERRUPT

;********************************************************************************

;Start of program memory page 0
	ORG	12
BASPROGRAMSTART
;Call initialisation routines
	rcall	INITSYS
	rcall	HIC2INIT
	rcall	HI2CMESSAGEHANDLER_PROCESS_INIT
	rcall	INITSOUND
;Enable interrupts
	bsf	INTCON,GIE,ACCESS
	bsf	INTCON,PEIE,ACCESS

;Start of the main program
;+************************************************************************************
;+ Author  : Mike Stevens G7GTN
;+ Date    : August 2017
;+ Version : 1.00
;+------------------------------------------------------------------------------------
;
;Purpose     : Provide a very simple I2C controlled 4 Channel Video Switcher
;
;
;Compiler    : http://gcbasic.sourceforge.net/
;Version     : 0.97.01
;Hardware    : The switcher is based on parts of the VK4XRL Digital World Series
;from CQ-DATV Magazines 41 & 42
;
;PIC I/O     :
;
;RA.0 LED 1
;RA.1 LED 2
;RA.2 LED 3
;RA.3 LED 4
;RB.0 74HC4351 S0
;RB.1 74HC4351 S1
;RB.2 74HC4351 S2
;RB.3 74HC4351 LATCH
;RC.3 SDA
;RC.4 SCL
;RC.7 8R SPEAKER
;
;
;I2C Address : 0x99 hex    <---- Change this address if so required
;
;************************************************************************************
;---'''Configuration
;#define HI2CBUFFERSIZE 16
;#define HI2CSlaveEnableStartStopInterrupts
;#define hi2c_BAUD_RATE 100
;#define hi2c_DATA PORTc.3
;#define hi2c_CLOCK PORTc.4
;Dir hi2c_DATA in
	bsf	TRISC,3,ACCESS
;Dir hi2c_CLOCK in
	bsf	TRISC,4,ACCESS
;---'''Define Hardware I/O settings
;#define LED1  porta.0
;#define LED2  porta.1
;#define LED3  porta.2
;#define LED4  porta.3
;#define SoundOut portc.7
;#define 74HC4351_S0 portb.0
;#define 74HC4351_S1 portb.1
;#define 74HC4351_S2 portb.2
;#define 74HC4351_LATCH portb.3
;dir LED1 out
	bcf	TRISA,0,ACCESS
;dir LED2 out
	bcf	TRISA,1,ACCESS
;dir LED3 out
	bcf	TRISA,2,ACCESS
;dir LED4 out
	bcf	TRISA,3,ACCESS
;dir 74HC4351_S0 out
	bcf	TRISB,0,ACCESS
;dir 74HC4351_S1 out
	bcf	TRISB,1,ACCESS
;dir 74HC4351_S2 out
	bcf	TRISB,2,ACCESS
;dir 74HC4351_LATCH out
	bcf	TRISB,3,ACCESS
;---'''Variables
;dim HI2CForLoop as byte
;---'''Main body of program commences here.
;HI2CSetAddress 0x99             ' Change I2C bus address here if required
	movlw	153
	movwf	I2CADDRESS,BANKED
	rcall	HI2CSETADDRESS

;HI2CMode Slave
	clrf	HI2CCURRENTMODE,BANKED
	rcall	HI2CMODE

;HI2CSlave_ISR_Init
	rcall	HI2CSLAVE_ISR_INIT

;On Interrupt  SSP1Ready call HI2CSlave_ISR_Handler
	bsf	PIE1,SSPIE,ACCESS
;do Forever
SysDoLoop_S1
;Loop
	bra	SysDoLoop_S1
SysDoLoop_E1
BASPROGRAMEND
	sleep
	bra	BASPROGRAMEND

;********************************************************************************

ACKNOWLEDGE
;Tone 440, 1000            ' Frequency / duration
	movlw	184
	movwf	TONEFREQUENCY,BANKED
	movlw	1
	movwf	TONEFREQUENCY_H,BANKED
	movlw	232
	movwf	TONEDURATION,BANKED
	movlw	3
	movwf	TONEDURATION_H,BANKED
	rcall	TONE

	return

;********************************************************************************

Delay_10US
D10US_START
	movlw	12
	movwf	DELAYTEMP,ACCESS
DelayUS0
	decfsz	DELAYTEMP,F,ACCESS
	bra	DelayUS0
	decfsz	SysWaitTemp10US, F,ACCESS
	bra	D10US_START
	return

;********************************************************************************

HI2CMESSAGEHANDLER_PROCESS_INIT
;HI2CIndex = 0
	clrf	HI2CINDEX,BANKED
;HI2CDATAPRESENT = false
	clrf	HI2CDATAPRESENT,BANKED
;HI2CDATAREQUESTED = false
	clrf	HI2CDATAREQUESTED,BANKED
;for HI2CForLoop = 0 to HI2CBUFFERSIZE
	setf	HI2CFORLOOP,BANKED
SysForLoop1
	incf	HI2CFORLOOP,F,BANKED
;HI2CBUFFER(HI2CForLoop) = 0
	lfsr	0,HI2CBUFFER
	movf	HI2CFORLOOP,W,BANKED
	addwf	AFSR0,F,ACCESS
	movlw	0
	addwfc	AFSR0_H,F,ACCESS
	clrf	INDF0,ACCESS
;next
	movlw	16
	subwf	HI2CFORLOOP,W,BANKED
	btfss	STATUS, C,ACCESS
	bra	SysForLoop1
SysForLoopEnd1
	return

;********************************************************************************

HI2CMESSAGEHANDLER_PROCESS_MESSAGE
;if (HI2CDATAPRESENT = true) then
	incf	HI2CDATAPRESENT,W,BANKED
	btfss	STATUS, Z,ACCESS
	bra	ENDIF22
;I2CTemp = HI2CIndex
	movff	HI2CINDEX,I2CTEMP
;HI2C_Process_In_Message( I2CTemp )
	movff	I2CTEMP,HI2CMESSAGESIZE
	rcall	HI2C_PROCESS_IN_MESSAGE

;HI2CDATAPRESENT = false
	clrf	HI2CDATAPRESENT,BANKED
;end if
ENDIF22
;if HI2CDATAREQUESTED = true then
	incf	HI2CDATAREQUESTED,W,BANKED
	btfss	STATUS, Z,ACCESS
	bra	ENDIF23
;HI2C_Process_Out_Message
	rcall	HI2C_PROCESS_OUT_MESSAGE

;HI2CDATAREQUESTED = false
	clrf	HI2CDATAREQUESTED,BANKED
;end if
ENDIF23
;HI2CIndex = 0
	clrf	HI2CINDEX,BANKED
	return

;********************************************************************************

HI2CMESSAGEHANDLER_STATE_1
;HI2CMessageHandler_Process_Message
	rcall	HI2CMESSAGEHANDLER_PROCESS_MESSAGE

	return

;********************************************************************************

HI2CMESSAGEHANDLER_STATE_2
;HI2CDATAPRESENT   = true      ' Indicate we received data
	setf	HI2CDATAPRESENT,BANKED
;HI2CBUFFER(HI2CIndex) = I2CByte
	lfsr	0,HI2CBUFFER
	movf	HI2CINDEX,W,BANKED
	addwf	AFSR0,F,ACCESS
	movlw	0
	addwfc	AFSR0_H,F,ACCESS
	movff	I2CBYTE,INDF0
;if (HI2CIndex < HI2CBUFFERSIZE) then
	movlw	16
	subwf	HI2CINDEX,W,BANKED
	btfss	STATUS, C,ACCESS
;HI2CIndex = HI2CIndex + 1   ' point to next position
	incf	HI2CINDEX,F,BANKED
;end if
	return

;********************************************************************************

HI2CMESSAGEHANDLER_STATE_3
;HI2CDATAREQUESTED = true
	setf	HI2CDATAREQUESTED,BANKED
;HI2CMessageHandler_Process_Message
	rcall	HI2CMESSAGEHANDLER_PROCESS_MESSAGE

	return

;********************************************************************************

HI2CMESSAGEHANDLER_STATE_4
;HI2CDATAREQUESTED = true
	setf	HI2CDATAREQUESTED,BANKED
;HI2CMessageHandler_Process_Message
	rcall	HI2CMESSAGEHANDLER_PROCESS_MESSAGE

;HI2CSlave_WriteI2CByte(HI2CBUFFER(0))   ' send first databyte
	movff	SYSHI2CBUFFER_0,I2CBYTE
	rcall	HI2CSLAVE_WRITEI2CBYTE

;HI2CIndex = 1                           ' point to next position
	movlw	1
	movwf	HI2CINDEX,BANKED
	return

;********************************************************************************

HI2CMESSAGEHANDLER_STATE_5
;HI2CDATAREQUESTED = true
	setf	HI2CDATAREQUESTED,BANKED
;HI2CSlave_WriteI2CByte(HI2CBUFFER(HI2CIndex))    ' send data
	lfsr	0,HI2CBUFFER
	movf	HI2CINDEX,W,BANKED
	addwf	AFSR0,F,ACCESS
	movlw	0
	addwfc	AFSR0_H,F,ACCESS
	movff	INDF0,I2CBYTE
	rcall	HI2CSLAVE_WRITEI2CBYTE

;if (HI2CIndex < HI2CBUFFERSIZE) then
	movlw	16
	subwf	HI2CINDEX,W,BANKED
	btfss	STATUS, C,ACCESS
;HI2CIndex = HI2CIndex + 1   ' point to next position
	incf	HI2CINDEX,F,BANKED
;end if
	return

;********************************************************************************

HI2CMESSAGEHANDLER_STATE_ERROR
	return

;********************************************************************************

HI2CMESSAGEHANDLER_STATE_ON_START
	return

;********************************************************************************

HI2CMESSAGEHANDLER_STATE_ON_STOP
;let user process buffer
;HI2CMessageHandler_Process_Message
	rcall	HI2CMESSAGEHANDLER_PROCESS_MESSAGE

	return

;********************************************************************************

HI2CMODE
;#ifndef Var(SSPCON1)
;#ifdef Var(SSPCON)
;Dim SSPCON1 Alias SSPCON
;#endif
;#endif
;set SSPSTAT.SMP on
	bsf	SSPSTAT,SMP,ACCESS
;set SSPCON1.CKP on
	bsf	SSPCON1,CKP,ACCESS
;set SSPCON1.WCOL Off
	bcf	SSPCON1,WCOL,ACCESS
;If HI2CCurrentMode = Master Then
	movlw	12
	subwf	HI2CCURRENTMODE,W,BANKED
	btfss	STATUS, Z,ACCESS
	bra	ENDIF14
;set SSPCON1.SSPM3 on
	bsf	SSPCON1,SSPM3,ACCESS
;set SSPCON1.SSPM2 off
	bcf	SSPCON1,SSPM2,ACCESS
;set SSPCON1.SSPM1 off
	bcf	SSPCON1,SSPM1,ACCESS
;set SSPCON1.SSPM0 off
	bcf	SSPCON1,SSPM0,ACCESS
;SSPADD = HI2C_BAUD_TEMP And 127
	movlw	39
	movwf	SSPADD,ACCESS
;end if
ENDIF14
;if HI2CCurrentMode = Slave then
	movf	HI2CCURRENTMODE,F,BANKED
	btfss	STATUS, Z,ACCESS
	bra	ENDIF15
;set SSPCON1.SSPM3 off
	bcf	SSPCON1,SSPM3,ACCESS
;set SSPCON1.SSPM2 on
	bsf	SSPCON1,SSPM2,ACCESS
;set SSPCON1.SSPM1 on
	bsf	SSPCON1,SSPM1,ACCESS
;set SSPCON1.SSPM0 off
	bcf	SSPCON1,SSPM0,ACCESS
;end if
ENDIF15
;if HI2CCurrentMode = Slave10 then
	movlw	3
	subwf	HI2CCURRENTMODE,W,BANKED
	btfss	STATUS, Z,ACCESS
	bra	ENDIF16
;set SSPCON1.SSPM3 off
	bcf	SSPCON1,SSPM3,ACCESS
;set SSPCON1.SSPM2 on
	bsf	SSPCON1,SSPM2,ACCESS
;set SSPCON1.SSPM1 on
	bsf	SSPCON1,SSPM1,ACCESS
;set SSPCON1.SSPM0 on
	bsf	SSPCON1,SSPM0,ACCESS
;end if
ENDIF16
;set SSPCON1.SSPEN on
	bsf	SSPCON1,SSPEN,ACCESS
	return

;********************************************************************************

HI2CSETADDRESS
;If HI2CCurrentMode <= 10 Then
	movf	HI2CCURRENTMODE,W,BANKED
	sublw	10
	btfsc	STATUS, C,ACCESS
;SSPADD = I2CAddress
	movff	I2CADDRESS,SSPADD
;End If
	return

;********************************************************************************

HI2CSLAVE_ISR_HANDLER
;if sspif = 0 then exit sub
	btfss	PIR1,SSPIF,ACCESS
	return
;SSPIF = 0
	bcf	PIR1,SSPIF,ACCESS
;HI2CSlavetmpstat = SSPSTAT
	movff	SSPSTAT,HI2CSLAVETMPSTAT
OVERFLOWSTATE
;if ( SSPOV = 1 ) then
	btfss	SSPCON1,SSPOV,ACCESS
	bra	ENDIF2
;I2Ctemp = SSPBUF
	movff	SSPBUF,I2CTEMP
;I2Ctemp = SSPBUF
	movff	SSPBUF,I2CTEMP
;SSPOV = 0
	bcf	SSPCON1,SSPOV,ACCESS
;HI2CSlave_State_Error ( HI2CSlaveSSPOVOverflowError )
	movlw	1
	movwf	HI2CERRORCODE,BANKED
	rcall	HI2CMESSAGEHANDLER_STATE_ERROR

;end if
ENDIF2
;I2Ctemp = ( HI2CSlavetmpstat & 0b00001111 )
	movlw	15
	andwf	HI2CSLAVETMPSTAT,W,BANKED
	movwf	I2CTEMP,BANKED
;I2CTemp = I2CTemp | 0b00000001
	movlw	1
	iorwf	I2CTEMP,F,BANKED
;if I2Ctemp = 0b00001001 then
	movlw	9
	subwf	I2CTEMP,W,BANKED
	btfss	STATUS, Z,ACCESS
	bra	ENDIF3
;HI2CSlave_State_On_Start
	rcall	HI2CMESSAGEHANDLER_STATE_ON_START

;if BF = 0 then Exit Sub
	btfss	SSPSTAT,BF,ACCESS
	return
;end if
ENDIF3
;I2Ctemp = ( HI2CSlavetmpstat & 0b00010000 )
	movlw	16
	andwf	HI2CSLAVETMPSTAT,W,BANKED
	movwf	I2CTEMP,BANKED
;I2Ctemp = I2Ctemp  | 0b00100001
	movlw	33
	iorwf	I2CTEMP,F,BANKED
;if I2Ctemp = 0b00110001 then
	movlw	49
	subwf	I2CTEMP,W,BANKED
	btfss	STATUS, Z,ACCESS
	bra	ENDIF4
;HI2CSlave_State_On_Stop
	rcall	HI2CMESSAGEHANDLER_STATE_ON_STOP

;if BF = 0 then Exit Sub
	btfss	SSPSTAT,BF,ACCESS
	return
;end if
ENDIF4
;HI2CSlavetmpstat = HI2CSlavetmpstat & 0b00101101
	movlw	45
	andwf	HI2CSLAVETMPSTAT,F,BANKED
STATE1
;if ( HI2CSlavetmpstat XOR 0b00001001 ) = 0  then
	movlw	9
	xorwf	HI2CSLAVETMPSTAT,W,BANKED
	movwf	SysTemp1,BANKED
	movff	SysTemp1,SysBYTETempA
	clrf	SysBYTETempB,ACCESS
	rcall	SysCompEqual
	btfss	SysByteTempX,0,ACCESS
	bra	ELSE5_1
;HSerSend 0x01
;I2Ctemp = SSPBUF
	movff	SSPBUF,I2CTEMP
;HI2CSlave_State_1( I2Ctemp )
	movff	I2CTEMP,I2CBYTE
	rcall	HI2CMESSAGEHANDLER_STATE_1

;else
	bra	ENDIF5
ELSE5_1
STATE2
;i2ctemp = HI2CSlavetmpstat OR  0b00001001
	movlw	9
	iorwf	HI2CSLAVETMPSTAT,W,BANKED
	movwf	I2CTEMP,BANKED
;i2ctemp = i2ctemp XOR 0b00101001
	movlw	41
	xorwf	I2CTEMP,F,BANKED
;if i2ctemp = 0 then
	movf	I2CTEMP,F,BANKED
	btfss	STATUS, Z,ACCESS
	bra	ELSE8_1
;HSerSend 0x02
;HI2CSlave_State_2( SSPBUF )
	movff	SSPBUF,I2CBYTE
	rcall	HI2CMESSAGEHANDLER_STATE_2

;if S = 0 then
	btfsc	SSPSTAT,S,ACCESS
	bra	ENDIF9
STATE3
;HSerSend 0x03
;HI2CSlave_State_3
	rcall	HI2CMESSAGEHANDLER_STATE_3

;CKP = 1
	bsf	SSPCON1,CKP,ACCESS
;end if
ENDIF9
;else
	bra	ENDIF8
ELSE8_1
STATE4
;i2ctemp = HI2CSlavetmpstat XOR 0b00001101
	movlw	13
	xorwf	HI2CSLAVETMPSTAT,W,BANKED
	movwf	I2CTEMP,BANKED
;if i2ctemp = 0 then
	movf	I2CTEMP,F,BANKED
	btfsc	STATUS, Z,ACCESS
;i2ctemp = SSPBUF
	movff	SSPBUF,I2CTEMP
;end if
;i2ctemp = HI2CSlavetmpstat OR 0b00000001
	movlw	1
	iorwf	HI2CSLAVETMPSTAT,W,BANKED
	movwf	I2CTEMP,BANKED
;i2ctemp = i2ctemp XOR 0b00001101
	movlw	13
	xorwf	I2CTEMP,F,BANKED
;if i2ctemp = 0 then
	movf	I2CTEMP,F,BANKED
	btfss	STATUS, Z,ACCESS
	bra	ELSE11_1
;HSerSend 0x04
;HI2CSlave_State_4
	rcall	HI2CMESSAGEHANDLER_STATE_4

;else
	bra	ENDIF11
ELSE11_1
STATE5
;if (HI2CSlavetmpstat XOR 0b00101100) = false then
	movlw	44
	xorwf	HI2CSLAVETMPSTAT,W,BANKED
	movwf	SysTemp1,BANKED
	movff	SysTemp1,SysBYTETempA
	clrf	SysBYTETempB,ACCESS
	rcall	SysCompEqual
	btfss	SysByteTempX,0,ACCESS
	bra	ELSE12_1
;HI2CSlave_State_5
	rcall	HI2CMESSAGEHANDLER_STATE_5

;HSerSend 0x05
;else
	bra	ENDIF12
ELSE12_1
STATE6
;if (HI2CSlavetmpstat XOR 0b00101000) = false  then
	movlw	40
	xorwf	HI2CSLAVETMPSTAT,W,BANKED
	movwf	SysTemp1,BANKED
	movff	SysTemp1,SysBYTETempA
	clrf	SysBYTETempB,ACCESS
	rcall	SysCompEqual
	btfss	SysByteTempX,0,ACCESS
	bra	ELSE13_1
;HSerSend 0x06
;CKP = 1
	bsf	SSPCON1,CKP,ACCESS
;HI2CSlave_State_6
	rcall	HI2CSLAVE_STATE_6

;else
	bra	ENDIF13
ELSE13_1
STATEERROR
;HSerSend 0x07
;CKP = 1
	bsf	SSPCON1,CKP,ACCESS
;HI2CSlave_State_Error ( HI2CSlaveStateNotHandledError )
	movlw	2
	movwf	HI2CERRORCODE,BANKED
	rcall	HI2CMESSAGEHANDLER_STATE_ERROR

;end if
ENDIF13
;end if
ENDIF12
;end if
ENDIF11
;end if
ENDIF8
;end if
ENDIF5
	return

;********************************************************************************

HI2CSLAVE_ISR_INIT
;SSPCON1 = SSPCON1 | 0b00001000     'enable start/stop interrupts
	movlw	8
	iorwf	SSPCON1,F,ACCESS
	return

;********************************************************************************

HI2CSLAVE_STATE_6
	return

;********************************************************************************

HI2CSLAVE_WRITEI2CBYTE
;Wait Until BF = 0
SysWaitLoop1
	btfsc	SSPSTAT,BF,ACCESS
	bra	SysWaitLoop1
;dim I2CTemp as Byte
;I2CTemp = 1
	movlw	1
	movwf	I2CTEMP,BANKED
;do while I2CTemp = 1
SysDoLoop_S2
	decf	I2CTEMP,W,BANKED
	btfss	STATUS, Z,ACCESS
	bra	SysDoLoop_E2
;WCOL = 0
	bcf	SSPCON1,WCOL,ACCESS
;try to write into buffer, checking collision
;SSPBUF = I2CByte
	movff	I2CBYTE,SSPBUF
;if WCOL = 0 then
	btfss	SSPCON1,WCOL,ACCESS
;I2CTemp = 0
	clrf	I2CTEMP,BANKED
;end if
;else continue trying
;loop
	bra	SysDoLoop_S2
SysDoLoop_E2
;CKP = 1
	bsf	SSPCON1,CKP,ACCESS
	return

;********************************************************************************

HI2C_PROCESS_IN_MESSAGE
;Select CASE HI2CBUFFER(0)
;Case 0x00
SysSelect1Case1
	banksel	SYSHI2CBUFFER_0
	movf	SYSHI2CBUFFER_0,F,BANKED
	btfss	STATUS, Z,ACCESS
	bra	SysSelect1Case2
;Acknowledge       ' Audio tone
	banksel	0
	rcall	ACKNOWLEDGE

;LED1 = 0
	bcf	LATA,0,ACCESS
;LED2 = 0
	bcf	LATA,1,ACCESS
;LED3 = 0
	bcf	LATA,2,ACCESS
;LED4 = 0
	bcf	LATA,3,ACCESS
;Case 0x01            ' Channel 1
	bra	SysSelectEnd1
SysSelect1Case2
	decf	SYSHI2CBUFFER_0,W,BANKED
	btfss	STATUS, Z,ACCESS
	bra	SysSelect1Case3
;Acknowledge
	banksel	0
	rcall	ACKNOWLEDGE

;LED1 = 1
	bsf	LATA,0,ACCESS
;74HC4351_S0 = 0
	bcf	LATB,0,ACCESS
;74HC4351_S1 = 0
	bcf	LATB,1,ACCESS
;74HC4351_S2 = 0
	bcf	LATB,2,ACCESS
;74HC4351_LATCH = 1   ' Pull latch enable to +5V via I/O Pin
	bsf	LATB,3,ACCESS
;Case 0x02            ' Channel 2
	bra	SysSelectEnd1
SysSelect1Case3
	movlw	2
	subwf	SYSHI2CBUFFER_0,W,BANKED
	btfss	STATUS, Z,ACCESS
	bra	SysSelect1Case4
;Acknowledge
	banksel	0
	rcall	ACKNOWLEDGE

;LED2 = 1
	bsf	LATA,1,ACCESS
;74HC4351_S0 = 1
	bsf	LATB,0,ACCESS
;74HC4351_S1 = 0
	bcf	LATB,1,ACCESS
;74HC4351_S2 = 0
	bcf	LATB,2,ACCESS
;74HC4351_LATCH = 1
	bsf	LATB,3,ACCESS
;Case 0x03            ' Channel 3
	bra	SysSelectEnd1
SysSelect1Case4
	movlw	3
	subwf	SYSHI2CBUFFER_0,W,BANKED
	btfss	STATUS, Z,ACCESS
	bra	SysSelect1Case5
;Acknowledge
	banksel	0
	rcall	ACKNOWLEDGE

;LED3 = 1
	bsf	LATA,2,ACCESS
;74HC4351_S0 = 0
	bcf	LATB,0,ACCESS
;74HC4351_S1 = 1
	bsf	LATB,1,ACCESS
;74HC4351_S2 = 0
	bcf	LATB,2,ACCESS
;74HC4351_LATCH = 1
	bsf	LATB,3,ACCESS
;Case 0x04            ' Channel 4
	bra	SysSelectEnd1
SysSelect1Case5
	movlw	4
	subwf	SYSHI2CBUFFER_0,W,BANKED
	btfss	STATUS, Z,ACCESS
	bra	SysSelect1Case6
;Acknowledge
	banksel	0
	rcall	ACKNOWLEDGE

;LED4 = 1
	bsf	LATA,3,ACCESS
;74HC4351_S0 = 1
	bsf	LATB,0,ACCESS
;74HC4351_S1 = 1
	bsf	LATB,1,ACCESS
;74HC4351_S2 = 0
	bcf	LATB,2,ACCESS
;74HC4351_LATCH = 1
	bsf	LATB,3,ACCESS
;end Select
SysSelect1Case6
SysSelectEnd1
	banksel	0
	return

;********************************************************************************

HI2C_PROCESS_OUT_MESSAGE
	return

;********************************************************************************

HIC2INIT
;HI2CCurrentMode = 0
	clrf	HI2CCURRENTMODE,BANKED
	return

;********************************************************************************

INITSOUND
;dir SoundOut out
	bcf	TRISC,7,ACCESS
	return

;********************************************************************************

INITSYS
;nop             ' This is the routine for the OSCCON config
	nop
;Set IRCF2 On
	bsf	OSCCON,IRCF2,ACCESS
;Set IRCF1 On
	bsf	OSCCON,IRCF1,ACCESS
;Set IRCF0 On
	bsf	OSCCON,IRCF0,ACCESS
;BSR = 0
	clrf	BSR,ACCESS
;TBLPTRU = 0
	clrf	TBLPTRU,ACCESS
;SET ADFM OFF
	bcf	ADCON2,ADFM,ACCESS
;SET ADCON0.ADON OFF
	bcf	ADCON0,ADON,ACCESS
;SET PCFG3 ON
	bsf	ADCON1,PCFG3,ACCESS
;SET PCFG2 ON
	bsf	ADCON1,PCFG2,ACCESS
;SET PCFG1 ON
	bsf	ADCON1,PCFG1,ACCESS
;SET PCFG0 ON
	bsf	ADCON1,PCFG0,ACCESS
;CMCON = 7
	movlw	7
	movwf	CMCON,ACCESS
;PORTA = 0
	clrf	PORTA,ACCESS
;PORTB = 0
	clrf	PORTB,ACCESS
;PORTC = 0
	clrf	PORTC,ACCESS
;PORTE = 0
	clrf	PORTE,ACCESS
	return

;********************************************************************************

Interrupt
;Save Context
	movff	WREG,SysW
	movff	STATUS,SysSTATUS
	movff	BSR,SysBSR
;Store system variables
	movff	SysTemp1,SaveSysTemp1
	movff	SysByteTempA,SaveSysByteTempA
	movff	SysByteTempB,SaveSysByteTempB
	movff	SysByteTempX,SaveSysByteTempX
	movff	FSR0L,SaveFSR0L
	movff	FSR0H,SaveFSR0H
	movff	SysWordTempA_H,SaveSysWordTempA_H
	movff	SysWordTempB_H,SaveSysWordTempB_H
	movff	SysDivMultA,SaveSysDivMultA
	movff	SysDivMultA_H,SaveSysDivMultA_H
	movff	SysDivMultB,SaveSysDivMultB
	movff	SysDivMultB_H,SaveSysDivMultB_H
	movff	SysDivMultX,SaveSysDivMultX
	movff	SysDivMultX_H,SaveSysDivMultX_H
	movff	SysDivLoop,SaveSysDivLoop
	movff	SysWordTempX_H,SaveSysWordTempX_H
;On Interrupt handlers
	btfss	PIE1,SSPIE,ACCESS
	bra	NotSSPIF
	btfss	PIR1,SSPIF,ACCESS
	bra	NotSSPIF
	rcall	HI2CSLAVE_ISR_HANDLER
	bcf	PIR1,SSPIF,ACCESS
	bra	INTERRUPTDONE
NotSSPIF
;User Interrupt routine
INTERRUPTDONE
;Restore Context
;Restore system variables
	movff	SaveSysTemp1,SysTemp1
	movff	SaveSysByteTempA,SysByteTempA
	movff	SaveSysByteTempB,SysByteTempB
	movff	SaveSysByteTempX,SysByteTempX
	movff	SaveFSR0L,FSR0L
	movff	SaveFSR0H,FSR0H
	movff	SaveSysWordTempA_H,SysWordTempA_H
	movff	SaveSysWordTempB_H,SysWordTempB_H
	movff	SaveSysDivMultA,SysDivMultA
	movff	SaveSysDivMultA_H,SysDivMultA_H
	movff	SaveSysDivMultB,SysDivMultB
	movff	SaveSysDivMultB_H,SysDivMultB_H
	movff	SaveSysDivMultX,SysDivMultX
	movff	SaveSysDivMultX_H,SysDivMultX_H
	movff	SaveSysDivLoop,SysDivLoop
	movff	SaveSysWordTempX_H,SysWordTempX_H
	movff	SysW,WREG
	movff	SysSTATUS,STATUS
	movff	SysBSR,BSR
	retfie	0

;********************************************************************************

SYSCOMPEQUAL
;Dim SysByteTempA, SysByteTempB, SysByteTempX as byte
;setf SysByteTempX
	setf	SYSBYTETEMPX,ACCESS
;movf SysByteTempB, W
	movf	SYSBYTETEMPB, W,ACCESS
;cpfseq SysByteTempA
	cpfseq	SYSBYTETEMPA,ACCESS
;clrf SysByteTempX
	clrf	SYSBYTETEMPX,ACCESS
	return

;********************************************************************************

SYSCOMPEQUAL16
;dim SysWordTempA as word
;dim SysWordTempB as word
;dim SysByteTempX as byte
;clrf SysByteTempX
	clrf	SYSBYTETEMPX,ACCESS
;movf SysWordTempB, W
	movf	SYSWORDTEMPB, W,ACCESS
;cpfseq SysWordTempA
	cpfseq	SYSWORDTEMPA,ACCESS
;return
	return
;movf SysWordTempB_H, W
	movf	SYSWORDTEMPB_H, W,ACCESS
;cpfseq SysWordTempA_H
	cpfseq	SYSWORDTEMPA_H,ACCESS
;return
	return
;setf SysByteTempX
	setf	SYSBYTETEMPX,ACCESS
	return

;********************************************************************************

SYSCOMPLESSTHAN16
;dim SysWordTempA as word
;dim SysWordTempB as word
;dim SysByteTempX as byte
;clrf SysByteTempX
	clrf	SYSBYTETEMPX,ACCESS
;movf SysWordTempA_H,W
	movf	SYSWORDTEMPA_H,W,ACCESS
;subwf SysWordTempB_H,W
	subwf	SYSWORDTEMPB_H,W,ACCESS
;btfss STATUS,C
	btfss	STATUS,C,ACCESS
;return
	return
;movf SysWordTempB_H,W
	movf	SYSWORDTEMPB_H,W,ACCESS
;subwf SysWordTempA_H,W
	subwf	SYSWORDTEMPA_H,W,ACCESS
;bnc SCLT16True
	bnc	SCLT16TRUE
;movf SysWordTempB,W
	movf	SYSWORDTEMPB,W,ACCESS
;subwf SysWordTempA,W
	subwf	SYSWORDTEMPA,W,ACCESS
;btfsc STATUS,C
	btfsc	STATUS,C,ACCESS
;return
	return
SCLT16TRUE
;comf SysByteTempX,F
	comf	SYSBYTETEMPX,F,ACCESS
	return

;********************************************************************************

SYSDIVSUB16
;dim SysWordTempA as word
;dim SysWordTempB as word
;dim SysWordTempX as word
;dim SysDivMultA as word
;dim SysDivMultB as word
;dim SysDivMultX as word
;SysDivMultA = SysWordTempA
	movff	SYSWORDTEMPA,SYSDIVMULTA
	movff	SYSWORDTEMPA_H,SYSDIVMULTA_H
;SysDivMultB = SysWordTempB
	movff	SYSWORDTEMPB,SYSDIVMULTB
	movff	SYSWORDTEMPB_H,SYSDIVMULTB_H
;SysDivMultX = 0
	clrf	SYSDIVMULTX,ACCESS
	clrf	SYSDIVMULTX_H,ACCESS
;if SysDivMultB = 0 then
	movff	SYSDIVMULTB,SysWORDTempA
	movff	SYSDIVMULTB_H,SysWORDTempA_H
	clrf	SysWORDTempB,ACCESS
	clrf	SysWORDTempB_H,ACCESS
	rcall	SysCompEqual16
	btfss	SysByteTempX,0,ACCESS
	bra	ENDIF29
;SysWordTempA = 0
	clrf	SYSWORDTEMPA,ACCESS
	clrf	SYSWORDTEMPA_H,ACCESS
;exit sub
	return
;end if
ENDIF29
;SysDivLoop = 16
	movlw	16
	movwf	SYSDIVLOOP,ACCESS
SYSDIV16START
;set C off
	bcf	STATUS,C,ACCESS
;Rotate SysDivMultA Left
	rlcf	SYSDIVMULTA,F,ACCESS
	rlcf	SYSDIVMULTA_H,F,ACCESS
;Rotate SysDivMultX Left
	rlcf	SYSDIVMULTX,F,ACCESS
	rlcf	SYSDIVMULTX_H,F,ACCESS
;SysDivMultX = SysDivMultX - SysDivMultB
	movf	SYSDIVMULTB,W,ACCESS
	subwf	SYSDIVMULTX,F,ACCESS
	movf	SYSDIVMULTB_H,W,ACCESS
	subwfb	SYSDIVMULTX_H,F,ACCESS
;Set SysDivMultA.0 On
	bsf	SYSDIVMULTA,0,ACCESS
;If C Off Then
	btfsc	STATUS,C,ACCESS
	bra	ENDIF30
;Set SysDivMultA.0 Off
	bcf	SYSDIVMULTA,0,ACCESS
;SysDivMultX = SysDivMultX + SysDivMultB
	movf	SYSDIVMULTB,W,ACCESS
	addwf	SYSDIVMULTX,F,ACCESS
	movf	SYSDIVMULTB_H,W,ACCESS
	addwfc	SYSDIVMULTX_H,F,ACCESS
;End If
ENDIF30
;decfsz SysDivLoop, F
	decfsz	SYSDIVLOOP, F,ACCESS
;goto SysDiv16Start
	bra	SYSDIV16START
;SysWordTempA = SysDivMultA
	movff	SYSDIVMULTA,SYSWORDTEMPA
	movff	SYSDIVMULTA_H,SYSWORDTEMPA_H
;SysWordTempX = SysDivMultX
	movff	SYSDIVMULTX,SYSWORDTEMPX
	movff	SYSDIVMULTX_H,SYSWORDTEMPX_H
	return

;********************************************************************************

TONE
;dim ToneLoop as word
;dim ToneLoop2 as word
;If ToneFrequency = 0 Then Exit Sub
	movff	TONEFREQUENCY,SysWORDTempA
	movff	TONEFREQUENCY_H,SysWORDTempA_H
	clrf	SysWORDTempB,ACCESS
	clrf	SysWORDTempB_H,ACCESS
	rcall	SysCompEqual16
	btfsc	SysByteTempX,0,ACCESS
	return
;TonePeriod = 50000 / ToneFrequency
	movlw	80
	movwf	SysWORDTempA,ACCESS
	movlw	195
	movwf	SysWORDTempA_H,ACCESS
	movff	TONEFREQUENCY,SysWORDTempB
	movff	TONEFREQUENCY_H,SysWORDTempB_H
	rcall	SysDivSub16
	movff	SysWORDTempA,TONEPERIOD
;ToneFrequency = ToneFrequency / 100
	movff	TONEFREQUENCY,SysWORDTempA
	movff	TONEFREQUENCY_H,SysWORDTempA_H
	movlw	100
	movwf	SysWORDTempB,ACCESS
	clrf	SysWORDTempB_H,ACCESS
	rcall	SysDivSub16
	movff	SysWORDTempA,TONEFREQUENCY
	movff	SysWORDTempA_H,TONEFREQUENCY_H
;For ToneLoop = 1 to ToneDuration
	clrf	TONELOOP,BANKED
	clrf	TONELOOP_H,BANKED
	movlw	1
	movwf	SysWORDTempB,ACCESS
	clrf	SysWORDTempB_H,ACCESS
	movff	TONEDURATION,SysWORDTempA
	movff	TONEDURATION_H,SysWORDTempA_H
	rcall	SysCompLessThan16
	btfsc	SysByteTempX,0,ACCESS
	bra	SysForLoopEnd2
SysForLoop2
	incf	TONELOOP,F,BANKED
	btfsc	STATUS,Z,ACCESS
	incf	TONELOOP_H,F,BANKED
;For ToneLoop2 = 1 to ToneFrequency
	clrf	TONELOOP2,BANKED
	clrf	TONELOOP2_H,BANKED
	movlw	1
	movwf	SysWORDTempB,ACCESS
	clrf	SysWORDTempB_H,ACCESS
	movff	TONEFREQUENCY,SysWORDTempA
	movff	TONEFREQUENCY_H,SysWORDTempA_H
	rcall	SysCompLessThan16
	btfsc	SysByteTempX,0,ACCESS
	bra	SysForLoopEnd3
SysForLoop3
	incf	TONELOOP2,F,BANKED
	btfsc	STATUS,Z,ACCESS
	incf	TONELOOP2_H,F,BANKED
;Set SoundOut ON
	bsf	LATC,7,ACCESS
;SysToneDelay
	movff	TONEPERIOD,SysWaitTemp10US
	rcall	Delay_10US
;Set SoundOut OFF
	bcf	LATC,7,ACCESS
;SysToneDelay
	movff	TONEPERIOD,SysWaitTemp10US
	rcall	Delay_10US
;Next
	movff	TONELOOP2,SysWORDTempA
	movff	TONELOOP2_H,SysWORDTempA_H
	movff	TONEFREQUENCY,SysWORDTempB
	movff	TONEFREQUENCY_H,SysWORDTempB_H
	rcall	SysCompLessThan16
	btfsc	SysByteTempX,0,ACCESS
	bra	SysForLoop3
SysForLoopEnd3
;Next
	movff	TONELOOP,SysWORDTempA
	movff	TONELOOP_H,SysWORDTempA_H
	movff	TONEDURATION,SysWORDTempB
	movff	TONEDURATION_H,SysWORDTempB_H
	rcall	SysCompLessThan16
	btfsc	SysByteTempX,0,ACCESS
	bra	SysForLoop2
SysForLoopEnd2
	return

;********************************************************************************


 END
