;Program compiled by Great Cow BASIC (0.97.01 2017-02-20)
;Need help? See the GCBASIC forums at http://sourceforge.net/projects/gcbasic/forums,
;check the documentation or email w_cholmondeley at users dot sourceforge dot net.

;********************************************************************************

;Set up the assembler options (Chip type, clock source, other bits and pieces)
 LIST p=18F2520, r=DEC
#include <P18F2520.inc>
 CONFIG LVP = OFF, MCLRE = ON, WDT = OFF, OSC = INTIO67

;********************************************************************************

;Set aside memory locations for variables
HI2CBUFFER	EQU	1517
HI2CCURRENTMODE	EQU	1
HI2CDATAPRESENT	EQU	2
HI2CDATAREQUESTED	EQU	3
HI2CERRORCODE	EQU	4
HI2CFORLOOP	EQU	6
HI2CINDEX	EQU	7
HI2CMESSAGESIZE	EQU	8
HI2CSLAVETMPSTAT	EQU	10
I2CADDRESS	EQU	11
I2CBYTE	EQU	12
I2CTEMP	EQU	13
SAVEFSR0H	EQU	16
SAVEFSR0L	EQU	17
SAVESYSBYTETEMPA	EQU	18
SAVESYSBYTETEMPB	EQU	19
SAVESYSBYTETEMPX	EQU	20
SAVESYSTEMP1	EQU	21
SYSBSR	EQU	22
SYSBYTETEMPA	EQU	5
SYSBYTETEMPB	EQU	9
SYSBYTETEMPX	EQU	0
SYSSTATUS	EQU	15
SYSTEMP1	EQU	23
SYSTEMP2	EQU	24
SYSW	EQU	14

;********************************************************************************

;Alias variables
AFSR0	EQU	4073
AFSR0_H	EQU	4074
SYSHI2CBUFFER_0	EQU	1517

;********************************************************************************

;Vectors
	ORG	0
	goto	BASPROGRAMSTART
	ORG	8
	bra	INTERRUPT

;********************************************************************************

;Start of program memory page 0
	ORG	12
BASPROGRAMSTART
;Call initialisation routines
	rcall	INITSYS
	rcall	HIC2INIT
	rcall	HI2CMESSAGEHANDLER_PROCESS_INIT
;Enable interrupts
	bsf	INTCON,GIE,ACCESS
	bsf	INTCON,PEIE,ACCESS

;Start of the main program
;+************************************************************************************
;+ Author  : Mike Stevens G7GTN
;+ Date    : August 2017
;+ Version : 1.00
;+------------------------------------------------------------------------------------
;
;Purpose     : Test LEDs
;
;
;Compiler    : http://gcbasic.sourceforge.net/
;Version     : 0.97.01
;Hardware    : 18f2520
;
;PIC I/O     :
;
;RA.0 LED 1
;RA.1 LED 2
;RA.2 LED 3
;RA.3 LED 4
;RC.3 SDA
;RC.4 SCL
;
;
;I2C Address : 0x99 hex    <---- Change this address if so required
;
;************************************************************************************
;---'''Configuration
;#define HI2CBUFFERSIZE 16
;#define HI2CSlaveEnableStartStopInterrupts
;#define hi2c_BAUD_RATE 100
;#define hi2c_DATA PORTc.3
;#define hi2c_CLOCK PORTc.4
;Dir hi2c_DATA in
	bsf	TRISC,3,ACCESS
;Dir hi2c_CLOCK in
	bsf	TRISC,4,ACCESS
;---'''Define Hardware I/O settings
;#define LED1  porta.0
;#define LED2  porta.1
;#define LED3  porta.2
;#define LED4  porta.3
;dir LED1 out
	bcf	TRISA,0,ACCESS
;dir LED2 out
	bcf	TRISA,1,ACCESS
;dir LED3 out
	bcf	TRISA,2,ACCESS
;dir LED4 out
	bcf	TRISA,3,ACCESS
;---'''Variables
;dim HI2CForLoop as byte
;---'''Main body of program commences here.
;HI2CSetAddress 0x99             ' Change I2C bus address here if required
	movlw	153
	movwf	I2CADDRESS,BANKED
	rcall	HI2CSETADDRESS

;HI2CMode Slave
	clrf	HI2CCURRENTMODE,BANKED
	rcall	HI2CMODE

;HI2CSlave_ISR_Init
	rcall	HI2CSLAVE_ISR_INIT

;On Interrupt  SSP1Ready call HI2CSlave_ISR_Handler
	bsf	PIE1,SSPIE,ACCESS
;do Forever
SysDoLoop_S1
;Loop
	bra	SysDoLoop_S1
SysDoLoop_E1
BASPROGRAMEND
	sleep
	bra	BASPROGRAMEND

;********************************************************************************

HI2CMESSAGEHANDLER_PROCESS_INIT
;HI2CIndex = 0
	clrf	HI2CINDEX,BANKED
;HI2CDATAPRESENT = false
	clrf	HI2CDATAPRESENT,BANKED
;HI2CDATAREQUESTED = false
	clrf	HI2CDATAREQUESTED,BANKED
;for HI2CForLoop = 0 to HI2CBUFFERSIZE
	setf	HI2CFORLOOP,BANKED
SysForLoop1
	incf	HI2CFORLOOP,F,BANKED
;HI2CBUFFER(HI2CForLoop) = 0
	lfsr	0,HI2CBUFFER
	movf	HI2CFORLOOP,W,BANKED
	addwf	AFSR0,F,ACCESS
	movlw	0
	addwfc	AFSR0_H,F,ACCESS
	clrf	INDF0,ACCESS
;next
	movlw	16
	subwf	HI2CFORLOOP,W,BANKED
	btfss	STATUS, C,ACCESS
	bra	SysForLoop1
SysForLoopEnd1
	return

;********************************************************************************

HI2CMESSAGEHANDLER_PROCESS_MESSAGE
;if (HI2CDATAPRESENT = true) then
	incf	HI2CDATAPRESENT,W,BANKED
	btfss	STATUS, Z,ACCESS
	bra	ENDIF22
;I2CTemp = HI2CIndex
	movff	HI2CINDEX,I2CTEMP
;HI2C_Process_In_Message( I2CTemp )
	movff	I2CTEMP,HI2CMESSAGESIZE
	rcall	HI2C_PROCESS_IN_MESSAGE

;HI2CDATAPRESENT = false
	clrf	HI2CDATAPRESENT,BANKED
;end if
ENDIF22
;if HI2CDATAREQUESTED = true then
	incf	HI2CDATAREQUESTED,W,BANKED
	btfss	STATUS, Z,ACCESS
	bra	ENDIF23
;HI2C_Process_Out_Message
	rcall	HI2C_PROCESS_OUT_MESSAGE

;HI2CDATAREQUESTED = false
	clrf	HI2CDATAREQUESTED,BANKED
;end if
ENDIF23
;HI2CIndex = 0
	clrf	HI2CINDEX,BANKED
	return

;********************************************************************************

HI2CMESSAGEHANDLER_STATE_1
;HI2CMessageHandler_Process_Message
	rcall	HI2CMESSAGEHANDLER_PROCESS_MESSAGE

	return

;********************************************************************************

HI2CMESSAGEHANDLER_STATE_2
;HI2CDATAPRESENT   = true      ' Indicate we received data
	setf	HI2CDATAPRESENT,BANKED
;HI2CBUFFER(HI2CIndex) = I2CByte
	lfsr	0,HI2CBUFFER
	movf	HI2CINDEX,W,BANKED
	addwf	AFSR0,F,ACCESS
	movlw	0
	addwfc	AFSR0_H,F,ACCESS
	movff	I2CBYTE,INDF0
;if (HI2CIndex < HI2CBUFFERSIZE) then
	movlw	16
	subwf	HI2CINDEX,W,BANKED
	btfss	STATUS, C,ACCESS
;HI2CIndex = HI2CIndex + 1   ' point to next position
	incf	HI2CINDEX,F,BANKED
;end if
	return

;********************************************************************************

HI2CMESSAGEHANDLER_STATE_3
;HI2CDATAREQUESTED = true
	setf	HI2CDATAREQUESTED,BANKED
;HI2CMessageHandler_Process_Message
	rcall	HI2CMESSAGEHANDLER_PROCESS_MESSAGE

	return

;********************************************************************************

HI2CMESSAGEHANDLER_STATE_4
;HI2CDATAREQUESTED = true
	setf	HI2CDATAREQUESTED,BANKED
;HI2CMessageHandler_Process_Message
	rcall	HI2CMESSAGEHANDLER_PROCESS_MESSAGE

;HI2CSlave_WriteI2CByte(HI2CBUFFER(0))   ' send first databyte
	movff	SYSHI2CBUFFER_0,I2CBYTE
	rcall	HI2CSLAVE_WRITEI2CBYTE

;HI2CIndex = 1                           ' point to next position
	movlw	1
	movwf	HI2CINDEX,BANKED
	return

;********************************************************************************

HI2CMESSAGEHANDLER_STATE_5
;HI2CDATAREQUESTED = true
	setf	HI2CDATAREQUESTED,BANKED
;HI2CSlave_WriteI2CByte(HI2CBUFFER(HI2CIndex))    ' send data
	lfsr	0,HI2CBUFFER
	movf	HI2CINDEX,W,BANKED
	addwf	AFSR0,F,ACCESS
	movlw	0
	addwfc	AFSR0_H,F,ACCESS
	movff	INDF0,I2CBYTE
	rcall	HI2CSLAVE_WRITEI2CBYTE

;if (HI2CIndex < HI2CBUFFERSIZE) then
	movlw	16
	subwf	HI2CINDEX,W,BANKED
	btfss	STATUS, C,ACCESS
;HI2CIndex = HI2CIndex + 1   ' point to next position
	incf	HI2CINDEX,F,BANKED
;end if
	return

;********************************************************************************

HI2CMESSAGEHANDLER_STATE_ERROR
	return

;********************************************************************************

HI2CMESSAGEHANDLER_STATE_ON_START
	return

;********************************************************************************

HI2CMESSAGEHANDLER_STATE_ON_STOP
;let user process buffer
;HI2CMessageHandler_Process_Message
	rcall	HI2CMESSAGEHANDLER_PROCESS_MESSAGE

	return

;********************************************************************************

HI2CMODE
;#ifndef Var(SSPCON1)
;#ifdef Var(SSPCON)
;Dim SSPCON1 Alias SSPCON
;#endif
;#endif
;set SSPSTAT.SMP on
	bsf	SSPSTAT,SMP,ACCESS
;set SSPCON1.CKP on
	bsf	SSPCON1,CKP,ACCESS
;set SSPCON1.WCOL Off
	bcf	SSPCON1,WCOL,ACCESS
;If HI2CCurrentMode = Master Then
	movlw	12
	subwf	HI2CCURRENTMODE,W,BANKED
	btfss	STATUS, Z,ACCESS
	bra	ENDIF14
;set SSPCON1.SSPM3 on
	bsf	SSPCON1,SSPM3,ACCESS
;set SSPCON1.SSPM2 off
	bcf	SSPCON1,SSPM2,ACCESS
;set SSPCON1.SSPM1 off
	bcf	SSPCON1,SSPM1,ACCESS
;set SSPCON1.SSPM0 off
	bcf	SSPCON1,SSPM0,ACCESS
;SSPADD = HI2C_BAUD_TEMP And 127
	movlw	39
	movwf	SSPADD,ACCESS
;end if
ENDIF14
;if HI2CCurrentMode = Slave then
	movf	HI2CCURRENTMODE,F,BANKED
	btfss	STATUS, Z,ACCESS
	bra	ENDIF15
;set SSPCON1.SSPM3 off
	bcf	SSPCON1,SSPM3,ACCESS
;set SSPCON1.SSPM2 on
	bsf	SSPCON1,SSPM2,ACCESS
;set SSPCON1.SSPM1 on
	bsf	SSPCON1,SSPM1,ACCESS
;set SSPCON1.SSPM0 off
	bcf	SSPCON1,SSPM0,ACCESS
;end if
ENDIF15
;if HI2CCurrentMode = Slave10 then
	movlw	3
	subwf	HI2CCURRENTMODE,W,BANKED
	btfss	STATUS, Z,ACCESS
	bra	ENDIF16
;set SSPCON1.SSPM3 off
	bcf	SSPCON1,SSPM3,ACCESS
;set SSPCON1.SSPM2 on
	bsf	SSPCON1,SSPM2,ACCESS
;set SSPCON1.SSPM1 on
	bsf	SSPCON1,SSPM1,ACCESS
;set SSPCON1.SSPM0 on
	bsf	SSPCON1,SSPM0,ACCESS
;end if
ENDIF16
;set SSPCON1.SSPEN on
	bsf	SSPCON1,SSPEN,ACCESS
	return

;********************************************************************************

HI2CSETADDRESS
;If HI2CCurrentMode <= 10 Then
	movf	HI2CCURRENTMODE,W,BANKED
	sublw	10
	btfsc	STATUS, C,ACCESS
;SSPADD = I2CAddress
	movff	I2CADDRESS,SSPADD
;End If
	return

;********************************************************************************

HI2CSLAVE_ISR_HANDLER
;if sspif = 0 then exit sub
	btfss	PIR1,SSPIF,ACCESS
	return
;SSPIF = 0
	bcf	PIR1,SSPIF,ACCESS
;HI2CSlavetmpstat = SSPSTAT
	movff	SSPSTAT,HI2CSLAVETMPSTAT
OVERFLOWSTATE
;if ( SSPOV = 1 ) then
	btfss	SSPCON1,SSPOV,ACCESS
	bra	ENDIF2
;I2Ctemp = SSPBUF
	movff	SSPBUF,I2CTEMP
;I2Ctemp = SSPBUF
	movff	SSPBUF,I2CTEMP
;SSPOV = 0
	bcf	SSPCON1,SSPOV,ACCESS
;HI2CSlave_State_Error ( HI2CSlaveSSPOVOverflowError )
	movlw	1
	movwf	HI2CERRORCODE,BANKED
	rcall	HI2CMESSAGEHANDLER_STATE_ERROR

;end if
ENDIF2
;I2Ctemp = ( HI2CSlavetmpstat & 0b00001111 )
	movlw	15
	andwf	HI2CSLAVETMPSTAT,W,BANKED
	movwf	I2CTEMP,BANKED
;I2CTemp = I2CTemp | 0b00000001
	movlw	1
	iorwf	I2CTEMP,F,BANKED
;if I2Ctemp = 0b00001001 then
	movlw	9
	subwf	I2CTEMP,W,BANKED
	btfss	STATUS, Z,ACCESS
	bra	ENDIF3
;HI2CSlave_State_On_Start
	rcall	HI2CMESSAGEHANDLER_STATE_ON_START

;if BF = 0 then Exit Sub
	btfss	SSPSTAT,BF,ACCESS
	return
;end if
ENDIF3
;I2Ctemp = ( HI2CSlavetmpstat & 0b00010000 )
	movlw	16
	andwf	HI2CSLAVETMPSTAT,W,BANKED
	movwf	I2CTEMP,BANKED
;I2Ctemp = I2Ctemp  | 0b00100001
	movlw	33
	iorwf	I2CTEMP,F,BANKED
;if I2Ctemp = 0b00110001 then
	movlw	49
	subwf	I2CTEMP,W,BANKED
	btfss	STATUS, Z,ACCESS
	bra	ENDIF4
;HI2CSlave_State_On_Stop
	rcall	HI2CMESSAGEHANDLER_STATE_ON_STOP

;if BF = 0 then Exit Sub
	btfss	SSPSTAT,BF,ACCESS
	return
;end if
ENDIF4
;HI2CSlavetmpstat = HI2CSlavetmpstat & 0b00101101
	movlw	45
	andwf	HI2CSLAVETMPSTAT,F,BANKED
STATE1
;if ( HI2CSlavetmpstat XOR 0b00001001 ) = 0  then
	movlw	9
	xorwf	HI2CSLAVETMPSTAT,W,BANKED
	movwf	SysTemp1,BANKED
	movff	SysTemp1,SysBYTETempA
	clrf	SysBYTETempB,ACCESS
	rcall	SysCompEqual
	btfss	SysByteTempX,0,ACCESS
	bra	ELSE5_1
;HSerSend 0x01
;I2Ctemp = SSPBUF
	movff	SSPBUF,I2CTEMP
;HI2CSlave_State_1( I2Ctemp )
	movff	I2CTEMP,I2CBYTE
	rcall	HI2CMESSAGEHANDLER_STATE_1

;else
	bra	ENDIF5
ELSE5_1
STATE2
;i2ctemp = HI2CSlavetmpstat OR  0b00001001
	movlw	9
	iorwf	HI2CSLAVETMPSTAT,W,BANKED
	movwf	I2CTEMP,BANKED
;i2ctemp = i2ctemp XOR 0b00101001
	movlw	41
	xorwf	I2CTEMP,F,BANKED
;if i2ctemp = 0 then
	movf	I2CTEMP,F,BANKED
	btfss	STATUS, Z,ACCESS
	bra	ELSE8_1
;HSerSend 0x02
;HI2CSlave_State_2( SSPBUF )
	movff	SSPBUF,I2CBYTE
	rcall	HI2CMESSAGEHANDLER_STATE_2

;if S = 0 then
	btfsc	SSPSTAT,S,ACCESS
	bra	ENDIF9
STATE3
;HSerSend 0x03
;HI2CSlave_State_3
	rcall	HI2CMESSAGEHANDLER_STATE_3

;CKP = 1
	bsf	SSPCON1,CKP,ACCESS
;end if
ENDIF9
;else
	bra	ENDIF8
ELSE8_1
STATE4
;i2ctemp = HI2CSlavetmpstat XOR 0b00001101
	movlw	13
	xorwf	HI2CSLAVETMPSTAT,W,BANKED
	movwf	I2CTEMP,BANKED
;if i2ctemp = 0 then
	movf	I2CTEMP,F,BANKED
	btfsc	STATUS, Z,ACCESS
;i2ctemp = SSPBUF
	movff	SSPBUF,I2CTEMP
;end if
;i2ctemp = HI2CSlavetmpstat OR 0b00000001
	movlw	1
	iorwf	HI2CSLAVETMPSTAT,W,BANKED
	movwf	I2CTEMP,BANKED
;i2ctemp = i2ctemp XOR 0b00001101
	movlw	13
	xorwf	I2CTEMP,F,BANKED
;if i2ctemp = 0 then
	movf	I2CTEMP,F,BANKED
	btfss	STATUS, Z,ACCESS
	bra	ELSE11_1
;HSerSend 0x04
;HI2CSlave_State_4
	rcall	HI2CMESSAGEHANDLER_STATE_4

;else
	bra	ENDIF11
ELSE11_1
STATE5
;if (HI2CSlavetmpstat XOR 0b00101100) = false then
	movlw	44
	xorwf	HI2CSLAVETMPSTAT,W,BANKED
	movwf	SysTemp1,BANKED
	movff	SysTemp1,SysBYTETempA
	clrf	SysBYTETempB,ACCESS
	rcall	SysCompEqual
	btfss	SysByteTempX,0,ACCESS
	bra	ELSE12_1
;HI2CSlave_State_5
	rcall	HI2CMESSAGEHANDLER_STATE_5

;HSerSend 0x05
;else
	bra	ENDIF12
ELSE12_1
STATE6
;if (HI2CSlavetmpstat XOR 0b00101000) = false  then
	movlw	40
	xorwf	HI2CSLAVETMPSTAT,W,BANKED
	movwf	SysTemp1,BANKED
	movff	SysTemp1,SysBYTETempA
	clrf	SysBYTETempB,ACCESS
	rcall	SysCompEqual
	btfss	SysByteTempX,0,ACCESS
	bra	ELSE13_1
;HSerSend 0x06
;CKP = 1
	bsf	SSPCON1,CKP,ACCESS
;HI2CSlave_State_6
	rcall	HI2CSLAVE_STATE_6

;else
	bra	ENDIF13
ELSE13_1
STATEERROR
;HSerSend 0x07
;CKP = 1
	bsf	SSPCON1,CKP,ACCESS
;HI2CSlave_State_Error ( HI2CSlaveStateNotHandledError )
	movlw	2
	movwf	HI2CERRORCODE,BANKED
	rcall	HI2CMESSAGEHANDLER_STATE_ERROR

;end if
ENDIF13
;end if
ENDIF12
;end if
ENDIF11
;end if
ENDIF8
;end if
ENDIF5
	return

;********************************************************************************

HI2CSLAVE_ISR_INIT
;SSPCON1 = SSPCON1 | 0b00001000     'enable start/stop interrupts
	movlw	8
	iorwf	SSPCON1,F,ACCESS
	return

;********************************************************************************

HI2CSLAVE_STATE_6
	return

;********************************************************************************

HI2CSLAVE_WRITEI2CBYTE
;Wait Until BF = 0
SysWaitLoop1
	btfsc	SSPSTAT,BF,ACCESS
	bra	SysWaitLoop1
;dim I2CTemp as Byte
;I2CTemp = 1
	movlw	1
	movwf	I2CTEMP,BANKED
;do while I2CTemp = 1
SysDoLoop_S2
	decf	I2CTEMP,W,BANKED
	btfss	STATUS, Z,ACCESS
	bra	SysDoLoop_E2
;WCOL = 0
	bcf	SSPCON1,WCOL,ACCESS
;try to write into buffer, checking collision
;SSPBUF = I2CByte
	movff	I2CBYTE,SSPBUF
;if WCOL = 0 then
	btfss	SSPCON1,WCOL,ACCESS
;I2CTemp = 0
	clrf	I2CTEMP,BANKED
;end if
;else continue trying
;loop
	bra	SysDoLoop_S2
SysDoLoop_E2
;CKP = 1
	bsf	SSPCON1,CKP,ACCESS
	return

;********************************************************************************

HI2C_PROCESS_IN_MESSAGE
;Select CASE HI2CBUFFER(0)
;Case 0x00
SysSelect1Case1
	banksel	SYSHI2CBUFFER_0
	movf	SYSHI2CBUFFER_0,F,BANKED
	btfss	STATUS, Z,ACCESS
	bra	SysSelect1Case2
;LED1 = 0
	bcf	LATA,0,ACCESS
;LED2 = 0
	bcf	LATA,1,ACCESS
;LED3 = 0
	bcf	LATA,2,ACCESS
;LED4 = 0
	bcf	LATA,3,ACCESS
;Case 0x01            ' Channel 1
	bra	SysSelectEnd1
SysSelect1Case2
	decf	SYSHI2CBUFFER_0,W,BANKED
	btfss	STATUS, Z,ACCESS
	bra	SysSelect1Case3
;LED1 = 1
	bsf	LATA,0,ACCESS
;Case 0x02            ' Channel 2
	bra	SysSelectEnd1
SysSelect1Case3
	movlw	2
	subwf	SYSHI2CBUFFER_0,W,BANKED
	btfss	STATUS, Z,ACCESS
	bra	SysSelect1Case4
;LED2 = 1
	bsf	LATA,1,ACCESS
;Case 0x03            ' Channel 3
	bra	SysSelectEnd1
SysSelect1Case4
	movlw	3
	subwf	SYSHI2CBUFFER_0,W,BANKED
	btfss	STATUS, Z,ACCESS
	bra	SysSelect1Case5
;LED3 = 1
	bsf	LATA,2,ACCESS
;Case 0x04            ' Channel 4
	bra	SysSelectEnd1
SysSelect1Case5
	movlw	4
	subwf	SYSHI2CBUFFER_0,W,BANKED
	btfss	STATUS, Z,ACCESS
	bra	SysSelect1Case6
;LED4 = 1
	bsf	LATA,3,ACCESS
;end Select
SysSelect1Case6
SysSelectEnd1
	banksel	0
	return

;********************************************************************************

HI2C_PROCESS_OUT_MESSAGE
	return

;********************************************************************************

HIC2INIT
;HI2CCurrentMode = 0
	clrf	HI2CCURRENTMODE,BANKED
	return

;********************************************************************************

INITSYS
;nop             ' This is the routine for the OSCCON config
	nop
;Set IRCF2 On
	bsf	OSCCON,IRCF2,ACCESS
;Set IRCF1 On
	bsf	OSCCON,IRCF1,ACCESS
;Set IRCF0 On
	bsf	OSCCON,IRCF0,ACCESS
;BSR = 0
	clrf	BSR,ACCESS
;TBLPTRU = 0
	clrf	TBLPTRU,ACCESS
;SET ADFM OFF
	bcf	ADCON2,ADFM,ACCESS
;SET ADCON0.ADON OFF
	bcf	ADCON0,ADON,ACCESS
;SET PCFG3 ON
	bsf	ADCON1,PCFG3,ACCESS
;SET PCFG2 ON
	bsf	ADCON1,PCFG2,ACCESS
;SET PCFG1 ON
	bsf	ADCON1,PCFG1,ACCESS
;SET PCFG0 ON
	bsf	ADCON1,PCFG0,ACCESS
;CMCON = 7
	movlw	7
	movwf	CMCON,ACCESS
;PORTA = 0
	clrf	PORTA,ACCESS
;PORTB = 0
	clrf	PORTB,ACCESS
;PORTC = 0
	clrf	PORTC,ACCESS
;PORTE = 0
	clrf	PORTE,ACCESS
	return

;********************************************************************************

Interrupt
;Save Context
	movff	WREG,SysW
	movff	STATUS,SysSTATUS
	movff	BSR,SysBSR
;Store system variables
	movff	SysTemp1,SaveSysTemp1
	movff	SysByteTempA,SaveSysByteTempA
	movff	SysByteTempB,SaveSysByteTempB
	movff	SysByteTempX,SaveSysByteTempX
	movff	FSR0L,SaveFSR0L
	movff	FSR0H,SaveFSR0H
;On Interrupt handlers
	btfss	PIE1,SSPIE,ACCESS
	bra	NotSSPIF
	btfss	PIR1,SSPIF,ACCESS
	bra	NotSSPIF
	rcall	HI2CSLAVE_ISR_HANDLER
	bcf	PIR1,SSPIF,ACCESS
	bra	INTERRUPTDONE
NotSSPIF
;User Interrupt routine
INTERRUPTDONE
;Restore Context
;Restore system variables
	movff	SaveSysTemp1,SysTemp1
	movff	SaveSysByteTempA,SysByteTempA
	movff	SaveSysByteTempB,SysByteTempB
	movff	SaveSysByteTempX,SysByteTempX
	movff	SaveFSR0L,FSR0L
	movff	SaveFSR0H,FSR0H
	movff	SysW,WREG
	movff	SysSTATUS,STATUS
	movff	SysBSR,BSR
	retfie	0

;********************************************************************************

SYSCOMPEQUAL
;Dim SysByteTempA, SysByteTempB, SysByteTempX as byte
;setf SysByteTempX
	setf	SYSBYTETEMPX,ACCESS
;movf SysByteTempB, W
	movf	SYSBYTETEMPB, W,ACCESS
;cpfseq SysByteTempA
	cpfseq	SYSBYTETEMPA,ACCESS
;clrf SysByteTempX
	clrf	SYSBYTETEMPX,ACCESS
	return

;********************************************************************************


 END
