/*
 * +=============================================================================================+
 * | Program : testleds.ino                                                                      |
 * | Author  : Mike G7GTN                                                                        |
 * | Date    : August 2017                                                                       | 
 * +=============================================================================================+ 
 * 
 *  Send I2C commands to control PIC 18F2520 test LED's
*  
*   If you changed the I2C bus address in the GCB code then you also need to change 
*   it here to both match.
*   
*/

#include <Wire.h>

//--------------------------------------------------------------------------
// Main set-up
void setup() 
{ 
   Wire.begin(0x99);			      // Address must match GCB code  
   Serial.begin(115200);
   Serial.flush();                       
}

//--------------------------------------------------------------------------
// 
void loop() 
{
   Wire.write(0x01);			      // LED 1
   Wire.endTransmission(); 
   Serial.println("LED 1 ON");
   delay(1400);
   Wire.write(0x02);			      // LED 2
   Wire.endTransmission(); 
   Serial.println("LED 2 ON");
   delay(1400);
   Wire.write(0x03);			      // LED 3
   Wire.endTransmission(); 
   Serial.println("LED 3 ON");
   delay(1400);
   Wire.write(0x04);			      // LED 4
   Wire.endTransmission(); 
   Serial.println("LED 4 ON");
   delay(1400);
   Wire.write(0x00);            // LED's ALL OFF
   Wire.endTransmission();  
}
